#define BitPlane1         $3C
#define BitPlane2         $0A
_user_int_ram EQU $d2fd                 	;Where to put the interrupt handler


OpenGray:
	ld      hl,$C9FA+1018					;save that last 6 bytes of the _plotSScreen
    ld      de,$C9FA
    ld      bc,6
    ldir									;store it to the beggining of _plotSScreen
    res     2,(iy+$23)                      ;turn user int off (we dont want any accidents)
    ld      hl,TheInt	                    ;copy prog to user int buffer
    ld      de,_user_int_ram+1
    ld      bc,End0int-TheInt			   ;size of interrupt handler
    ldir                                    ;hl is the source, de is the destination,

    ld      a,(_user_int_ram+1)             ;setup the crappy checksum
    ld      hl,_user_int_ram+($28*1)
    add     a,(hl)
    ld      hl,_user_int_ram+($28*2)
    add     a,(hl)
    ld      hl,_user_int_ram+($28*3)
    add     a,(hl)
    ld      hl,_user_int_ram+($28*4)
    add     a,(hl)
    ld      hl,_user_int_ram+($28*5)
    add     a,(hl)
    ld      (_user_int_ram),a
    xor     a
    ld      (IntCounter), a
    ld      (UserCounter), a				;make some variables
    ld      de,BitPlanes
    ld      hl,BitPlaneData
    ld      bc,2
    ldir
    set     2,(iy+$23)						;turn on the grayscale!
    ret

CloseGray:
        res     2, (iy+$23)                 ;disable the jump to $d2fd
        ld      a, $3C						;make sure that the screen is pointing
        out     (0), a						;to the right place
        ld      de,$C9FA+1018				;redo the last 6 bytes
        ld      hl,$C9FA
        ld      bc,6						
		call	ClearBackPage
        ret

ClearBackPage
        ld      hl,$CA00
		xor		a
		ld		(hl),a
		ld		de,$CA01
        ld      bc, 1024
        ldir
		ret

TheInt:								;this is the actuall interrupt
        push    af					;dont overwrite the users vars
        push    hl
        in      a,(3)
        bit     1,a
        jr      z,Return2Program
        ld      hl,UserCounter		;inc the user counter
        inc     (hl)
        ld      hl,BitPlanes
        ld      a,(IntCounter)
        cp      5					;it its a 5, its time for the first bitplane
        jr      z,DisplayLast
        cp      3					;3 means the second bitplane
        jr      c,DisplayBitPlane1
        jr      DisplayBitPlane2

DisplayBitPlane1:                   ;$FC00 is the current bitplane
        inc     a
        ld      (IntCounter),a		;increment the Interrupt counter
        ld      a, (hl)
        out     (0),a
        jr      Return2Program

DisplayBitPlane2:                   ;Display 2nd bitplane $CA00
        inc     a
        ld      (IntCounter),a
        inc     hl
        ld      a, (hl)
        out     (0),a
        jr      Return2Program

DisplayLast:                        ;Re-do the First BitPlane
        ld      a, (hl)
        out     (0), a				
        xor     a					;and restart the int counter
        ld      (IntCounter),a

Return2Program:
        pop     hl
        pop     af
        ret

End0int:

IntCounter              equ _user_int_ram+End0int-TheInt+2
BitPlanes      		    equ _user_int_ram+End0int-TheInt+3
UserCounter             equ _user_int_ram+End0int-TheInt+5

BitPlaneData:
.db BitPlane1,BitPlane2

Screens:
.dw $FC00,$CA00

.end

