#include "asm86.h"
#include "ti86asm.inc"

_load_ram_ahl	equ		$462F	;Converts ahl to ASIC, loads RAM page.

_dispahl		equ		$4a33	;Displays ahl in decimal.

_runoff			equ		$4AB1	;Disable run indicator.

_runon			equ		$4AAD	;Enable run indicator.

_off			equ		$4101	;Turn off calc.

_getcode		equ		$4068	;Get scancode, but 1000's of clocks faster than GET_KEY.

_exec_basic		equ		$4C57	;Execute TI-BASIC program in OP1.

_exec_asm		equ		$5730	;Execute z80 assembly program in OP1.

_PrevVar		equ		$514F
_NextVar		equ		$514B
_load_ram_ahl	equ		$462F	;Converts ahl to ASIC, loads RAM page.

_pop_op1		equ		$47B7	;Pops OP1 from the FP stack.

_push_op1		equ		$4813	;Pushes OP1 onto the FP stack.

_FindAlphaUp	equ		$514B
_ldhlind        equ		$4010

#define		TotalIcons  		ProgEnd
#define		TotalVars			ProgEnd+2
#define		PointerPos  		ProgEnd+4
#define		Pointer2VAT 		ProgEnd+6
#define		Pointer2AVAT		ProgEnd+8
#define		AVAT				ProgEnd+10

.org _asm_exec_ram

;###################
;# Draw the Screen #
;###################

Program_Start:
	ei
	call	_clrScrn
	call	_runoff
	res		3,(iy+5)
	ld		hl,ProgEnd
	ld		b,10
ClearLoop:
	ld		(hl),0
	inc		hl
	djnz	ClearLoop
	call	GrayOn
	call	DrawDesktop
	call	GetFreeMem
	ld		b,15
	ld		c,2
	ld		hl,MyCalcSprite
	call	FastSprite
	ld		hl,$0A06
	ld		(_penCol),hl
	ld		hl,MyCalcStr
	call	_vputs

;###########################
;# Check if Plug-Ins Exist #
;###########################

DesktopIcons:
	ld		hl,AVAT
	ld		(Pointer2AVAT),hl
	ld		hl,FirstPossibleProgram
	rst		20h
CheckLoop:
	xor		a
	call	_FindAlphaUp
	jr		c,EndOfPrograms
	rst		10h
	ld		a,b
	ex		de,hl	
	call	_load_ram_ahl
	inc		hl
	inc		hl
	inc		hl
	inc		hl
	ld		a,(hl)
	cp		0
	jr		nz,CheckLoop
	inc		hl
	inc		hl
	inc		hl
	inc		hl
	ld		a,(hl)
	cp		$01
	jr		nz,CheckLoop
	ld		a,(TotalIcons)
	cp		8
	jr		z,EndOfPrograms
	inc		a
	ld		(TotalIcons),a
	ld		hl,_OP1
	ld		de,(Pointer2AVAT)
	ld		bc,10
	ldir
	ld		hl,(Pointer2AVAT)
	ld		de,10
	add		hl,de
	ld		(Pointer2AVAT),hl
	jr		CheckLoop

EndOfPrograms:
	ld		a,(TotalIcons)
	cp		0
	jp		z,None4Desktop
	push	af
	ld		a,2
	ld		(SpritePos),a
	call	FindSpriteCoords
	ld		hl,AVAT
	pop		af
	ld		b,a

DisplayIcons:
	push	bc
	push	hl
	rst		20h
	rst		10h
	ld		a,b
	ex		de,hl
	call	_load_ram_ahl
	in		a,(5)
	push	af
	in		a,(6)
	out		(5),a
	inc		a
	out		(6),a
	ld		de,-4000h
	add		hl,de
	push	hl

	ld		de,12

	add		hl,de

	ld		e,(hl)
	inc		hl
	ld		d,(hl)
	ex		de,hl
	ld		de,$D748-4

	sbc		hl,de

	pop		de

	add		hl,de

	ld		a,(hl)
	cp		8
	call	nz,UseStandardSprite
	inc		hl
	inc		hl
	ld		a,(SpriteX)
	ld		b,a
	ld		a,(SpriteY)
	ld		c,a
	call	FastSprite
	pop		af
	out		(5),a
	ld		a,(SpriteX)
	add		a,4
	push	af
	ld		a,(_OP1+1)
	add		a,a
	ld		b,a
	pop		af
	sub		b
	ld		(_penCol),a
	ld		a,(SpriteY)
	add		a,8
	ld		(_penRow),a
	ld		a,(_OP1+1)
	ld		b,a
	ld		hl,_OP1+2
	call	_vputsn
	ld		hl,SpritePos
	inc		(hl)
	call	FindSpriteCoords
	pop		hl
	ld		de,10
	add		hl,de
	pop		bc
	djnz	DisplayIcons

None4Desktop:
	call	BackUpScreen
	call	GetMouseXY
	ld		hl,MouseSprite
	call	FastSprite

StartGetLoop:
	halt
	halt
	ld		a,%01111110
	out		(1),a
	nop
	nop		
	in 		a,(1)
	bit		0,a
	call	z,MoveDown
	bit		1,a
	call	z,MoveLeft
	bit		2,a
	call	z,MoveRight
	bit		3,a
	call	z,MoveUp
	ld 		a,%00111111
	out 	(1),a
	nop 
	nop
	in		a,(1)
	bit		0,a
	jp		z,ExecShortcut4
	bit		1,a
	jp		z,ExecShortcut3
	bit		2,a
	jp		z,ExecShortcut2
	bit		3,a
	jp		z,ExecShortcut1
	bit		4,a
	jp		z,DrawMenu
	bit		5,a
	jp		z,ExecIconProgram
	bit		6,a
	jp		z,ExitShell
	ld		a,%011011111
	out		(1),a
	nop
	nop
	in		a,(1)
	bit		6,a
	jp		z,ControlPanel
	bit		7,a
	jp		z,RunEditor
	ld		a,%011111011
	out		(1),a
	nop
	nop
	in		a,(1)
	bit		6,a
	jp		z,RunProg
	ld		a,%01111101
	out		(1),a
	nop
	nop
	in		a,(1)
	bit		1,a
	call	z,ContrastUp
	bit		2,a
	call	z,ContrastDn
	bit		6,a
	call	z,ShutCalcOff
	ld		a,%01110111
	out		(1),a
	nop
	nop
	in		a,(1)
	bit		6,a
	jp		z,RunExplorer
	jp		StartGetLoop

MoveLeft:
	push	af
	call	GetMouseXY
	ld		a,1
	cp		b
	jr		z,PopIt
	call	RestoreScreen
	dec		b
	call	SaveMouseXY
	ld		hl,MouseSprite
	call	FastSprite
	pop		af
	ret

MoveRight:
	push	af
	call	GetMouseXY
	ld		a,119
	cp		b
	jr		z,PopIt
	call	RestoreScreen
	inc		b
	call	SaveMouseXY
	ld		hl,MouseSprite
	call	FastSprite
	pop		af
	ret

MoveUp:
	push	af
	call	GetMouseXY
	ld		a,1
	cp		c
	jr		z,PopIt
	call	RestoreScreen
	dec		c
	call	SaveMouseXY
	ld		hl,MouseSprite
	call	FastSprite
	pop		af
	ret

MoveDown:
	push	af
	call	GetMouseXY
	ld		a,48
	cp		c
	jr		z,PopIt
	call	RestoreScreen
	inc		c
	call	SaveMouseXY
	ld		hl,MouseSprite
	call	FastSprite
	pop		af
	ret

PopIt:
	pop		af
	ret

SaveMouseXY:
	ld		a,b
	ld		(MouseX),a
	ld		a,c
	ld		(MouseY),a
	ret

GetMouseXY:
	ld		a,(MouseX)
	ld		b,a
	ld		a,(MouseY)
	ld		c,a
	ret

ExecShortcut1:
	ld		hl,Shortcut1
	jr		ExecTheShortCut
ExecShortcut2:
	ld		hl,Shortcut2
	jr		ExecTheShortCut
ExecShortcut3:
	ld		hl,Shortcut3
	jr		ExecTheShortCut
ExecShortcut4:
	ld		hl,Shortcut4
ExecTheShortCut:
	push	hl
	call	SaveVars
	pop		hl
	rst		20h
	rst		10h
	jr		nc,ExecTheShortCutFinal
	call	ErrorNoProg
	jp		Program_Start
ExecTheShortCutFinal:
	call	ExecProgram
	jp		Program_Start

ExecIconProgram:
	call	GetMouseXY
	ld		hl,$0000
	ld		de,$2612
	call	InArea
	jp		z,Area1

	call	GetMouseXY
	ld		hl,$0012
	ld		de,$2624
	call	InArea
	jp		z,Area2

	call	GetMouseXY
	ld		hl,$0024
	ld		de,$2636
	call	InArea
	jp		z,Area3

	call	GetMouseXY
	ld		hl,$2600
	ld		de,$4812
	call	InArea
	jp		z,Area4

	call	GetMouseXY
	ld		hl,$2612
	ld		de,$4824
	call	InArea
	jp		z,Area5

	call	GetMouseXY
	ld		hl,$2624
	ld		de,$4836
	call	InArea
	jp		z,Area6

	call	GetMouseXY
	ld		hl,$4800
	ld		de,$7212
	call	InArea
	jp		z,Area7

	call	GetMouseXY
	ld		hl,$4812
	ld		de,$7224
	call	InArea
	jp		z,Area8

	call	GetMouseXY
	ld		hl,$4824
	ld		de,$7236
	call	InArea
	jp		z,Area9
	jp		StartGetLoop

Area1:
	jp		RunExplorer
Area2:
	ld		a,(TotalIcons)
	sub		1
	jp		c,StartGetLoop
	ld		hl,AVAT
	jr		ExecDesktopProgram
Area3:
	ld		a,(TotalIcons)
	sub		2
	jp		c,StartGetLoop
	ld		hl,AVAT+10
	jr		ExecDesktopProgram
Area4:
	ld		a,(TotalIcons)
	sub		3
	jp		c,StartGetLoop
	ld		hl,AVAT+10+10
	jr		ExecDesktopProgram
Area5:
	ld		a,(TotalIcons)
	sub		4
	jp		c,StartGetLoop
	ld		hl,AVAT+10+10+10
	jr		ExecDesktopProgram
Area6:
	ld		a,(TotalIcons)
	sub		5
	jp		c,StartGetLoop
	ld		hl,AVAT+10+10+10+10
	jr		ExecDesktopProgram
Area7:
	ld		a,(TotalIcons)
	sub		6
	jp		c,StartGetLoop
	ld		hl,AVAT+10+10+10+10+10
	jr		ExecDesktopProgram
Area8:
	ld		a,(TotalIcons)
	sub		7
	jp		c,StartGetLoop
	ld		hl,AVAT+10+10+10+10+10+10
	jr		ExecDesktopProgram
Area9:
	ld		a,(TotalIcons)
	sub		8
	jp		c,StartGetLoop
	ld		hl,AVAT+10+10+10+10+10+10+10
ExecDesktopProgram:
	push	hl
	call	SaveVars
	pop		hl
	rst		20h
	rst		10h
	call	ExecProgram
	jp		Program_Start

DrawMenu:
	call	RestoreScreen
	call	ClearStartMenu
	ld		b,34

	ld		de,MenuSprite
	ld		hl,$FD60
	call	DrawTallSprite
	ld		b,34

	ld		hl,$FD66

	ld		c,%10000000

	ld		de,16

	call	DrawVLine
	ld		b,33

	ld		hl,$FD76

	ld		c,%01000000

	ld		de,16

	call	DrawVLine
	ld		b,5
	ld		hl,$FD61
	call	DrawHLine
	ld		hl,$180B
	ld		(_penCol),hl
	ld		hl,ProgsStr
	call	_vputs
	ld		hl,$1E0B
	ld		(_penCol),hl
	ld		hl,DocsStr
	call	_vputs
	ld		hl,$240B
	ld		(_penCol),hl
	ld		hl,CtrlStr
	call	_vputs
	ld		hl,$2A0B
	ld		(_penCol),hl
	ld		hl,RunStr
	call	_vputs
	ld		hl,$300B
	ld		(_penCol),hl
	ld		hl,OffStr
	call	_vputs
	call	InvertSelector
	
MenuGetLoop:
	call	_getcode
	cp		K_UP
	jp		z,MenuMoveBarUp
	cp		K_DOWN
	jp		z,MenuMoveBarDown
	cp		K_SECOND
	jp		z,TaskChosen
	cp		K_EXIT
	jp		z,Program_Start
	cp		K_PLUS
	call	z,ContrastUp
	cp		K_MINUS
	call	z,ContrastDn
	jr		MenuGetLoop

MenuMoveBarUp:
	ld      a,(Pos)
	push	af
	call    InvertSelector
	pop		af
	cp      1
	call	z,HopBarDown
	dec     a
	ld		(Pos),a
	call    InvertSelector
	ld		a,(Pos)
	jp		MenuGetLoop
HopBarDown:
	ld		a,6
	ret

MenuMoveBarDown:
	ld      a,(Pos)
	push	af
	call    InvertSelector
	pop		af
	cp		5
	call	z,HopBarUp
	inc		a
	ld		(Pos),a
	call    InvertSelector
	jp		MenuGetLoop
HopBarUp:
	ld		a,0
	ret

TaskChosen:
	ld		a,(Pos)
	cp		1
	jp		z,RunExplorer
	cp		2
	jp		z,RunEditor
	cp		3
	jp		z,ControlPanel
	cp		4
	jp		z,RunProg
	cp		5
	call	z,ShutCalcOff
	jp		MenuGetLoop

RunExplorer:
	jp		ExplorerScreenSetup
	
RunEditor:
	ld		hl,EditorVAT
	rst		20h
	rst		10h
	jp		c,ErrorWithEditor
	ld		a,b
	ex		de,hl
	call	_exec_asm
	jp		Program_Start

ErrorWithEditor:
	call	ErrorNoProg
	jp		Program_Start

ControlPanel:
	call	DrawFullScreen
	ld		hl,$0125
	ld		(_penCol),hl
	ld		hl,ControlPanelStr
	call	_vputs
	ld		hl,$0A09
	ld		(_penCol),hl
	ld		hl,BackPicStr
	call	_vputs
	ld		hl,GrayPic
	rst		20h
	ld		hl,_OP1+2
	ld		a,(_OP1+1)
	ld		b,a
	call	_vputsn

	ld		hl,$1009
	ld		(_penCol),hl
	ld		hl,Shortcut1Str
	call	_vputs
	ld		hl,Shortcut1+2
	ld		a,(Shortcut1+1)
	ld		b,a
	call	_vputsn

	ld		hl,$1609
	ld		(_penCol),hl
	ld		hl,Shortcut2Str
	call	_vputs
	ld		hl,Shortcut2+2
	ld		a,(Shortcut2+1)
	ld		b,a
	call	_vputsn

	ld		hl,$1C09
	ld		(_penCol),hl
	ld		hl,Shortcut3Str
	call	_vputs
	ld		hl,Shortcut3+2
	ld		a,(Shortcut3+1)
	ld		b,a
	call	_vputsn

	ld		hl,$2209
	ld		(_penCol),hl
	ld		hl,Shortcut4Str
	call	_vputs
	ld		hl,Shortcut4+2
	ld		a,(Shortcut4+1)
	ld		b,a
	call	_vputsn

	ld		hl,$0A09
	ld		(_penCol),hl
	ld		a,1
	ld		(PointerPos),a
	call	ControlPlaceArrow

ControlGetLoop:
	call    _getcode
	cp      K_EXIT
	jp      z,ExitControlLoop
	cp		K_UP
	jp		z,ControlMovePointerUp
	cp		K_DOWN
	jp		z,ControlMovePointerDn
	cp      K_LEFT
	jp		z,ControlDecVarName
	cp      K_RIGHT
	jp		z,ControlIncVarName
	cp		K_CLEAR
	jp		z,ReLoadNoneVar
	jr      ControlGetLoop

ControlMovePointerUp:
	call	SaveNewVarName
	call	ControlEraseArrow
	ld		a,(PointerPos)
	cp		1
	call	z,ControlHopPointerDown
	dec		a
	ld		(PointerPos),a
	call	ControlPlaceArrow
	call	ControlGetVATOffset
	rst		20h
	jp		ControlGetLoop
ControlHopPointerDown:
	ld		a,6
	ret

ControlMovePointerDn:
	call	SaveNewVarName
	call	ControlEraseArrow
	ld		a,(PointerPos)
	cp		5
	call	z,ControlHopPointerUp
	inc		a
	ld		(PointerPos),a
	call	ControlPlaceArrow
	call	ControlGetVATOffset
	rst		20h
	jp		ControlGetLoop
ControlHopPointerUp:
	ld		a,0
	ret

ControlEraseArrow:
	call	ControlPointerOffset
	ld		hl,Spaces_Str
	call	_vputs
	ret

ControlPlaceArrow:
	call	ControlPointerOffset
	ld		a,$05
	call	_vputmap
	ret

ControlPointerOffset:
	ld		a,(PointerPos)
	ld		h,a
	ld		l,6
	call	MUL_HL
	ld		de,4
	add		hl,de
	ld		(_penRow),hl
	ld		a,03
	ld		(_penCol),a
	ret

ControlIncVarName:
	xor		a
	call	_NextVar
	call	c,LoadNoneVar
	call	ControlDispInfo
	jp		ControlGetLoop

ControlDecVarName:
	xor		a
	call	_PrevVar
	jp		c,ControlGetLoop
	call	ControlDispInfo
	jp		ControlGetLoop

ReLoadNoneVar:
	call	LoadNoneVar
	call	ControlDispInfo
	jp		ControlGetLoop

LoadNoneVar:
	ld		hl,NonePic
	ld		a,(PointerPos)
	cp		1
	jr		z,Load2OP1
	ld		hl,NoneProg
Load2OP1:
	rst		20h
	ret

ControlGetVATOffset:
	ld		a,(PointerPos)
	ld		h,a
	ld		l,11
	call	MUL_HL
	ld		de,GrayPic-11
	add		hl,de
	ret
	
ControlDispInfo:						
	call	ControlPointerOffset
	ld		b,37
	ld		a,(PointerPos)
	cp		1
	jr		z,ControlNoAdd4Prog
	ld		b,52
ControlNoAdd4Prog:
	ld		a,b
	ld		(_penCol),a
	ld		hl,_OP1+2
	ld		a,(_OP1+1)
	ld		b,a
	call	_vputsn
	ld		b,27
PutBSpaces:
	ld		a,' ' 
	call	_vputmap
	djnz	PutBSpaces	
	ret

SaveNewVarName:
	call	ControlGetVATOffset
	ex		de,hl
	ld		hl,_OP1
	ld		bc,10
	ldir
	ret

ExitControlLoop:
	call	SaveNewVarName
	call	GrayOff
	call	GrayOn
	jp		Program_Start

ExitShell:
	call	SaveVars
	call	GrayOff
	call	_clrLCD
	call	_homeup
	res		4,(iy+$09)
	ret

RunProg:
	call	DrawDialogBox
	ld		hl,$171E
	ld		(_penCol),hl
	ld		hl,EnterName
	call	_vputs
	ld		hl,TextBuffer
	ld		(TextPtr),hl
	ld		b,9
	ld		hl,TextBuffer
ClearBuffer:
	ld		(hl),0
	inc		hl
	djnz	ClearBuffer
	call	PutPrompt
	call	RunGetLoop
	cp		1
	jr		z,FinishRunProg
	call	ClearDialogArea
	jp		DrawMenu

FinishRunProg:	
	rst		10h
	jr		nc,ExistsRunIt
	call	ErrorNoProg
	jp		Program_Start

ExistsRunIt:
	call	ExecProgram
	jp		Program_Start

RunGetLoop:
	call	_getcode
	cp		K_EXIT
	jp		z,NoSaveName
	cp		K_ALPHA
	jp		z,ToggleAlpha
	cp		K_DEL
	jp		z,BackUp
	cp		K_ENTER
	jp		z,StringDone
	sub		10
    bit     7,a
	jr		c,RunGetLoop
	ld		hl,JumpTables
	ld		e,a
	ld		d,0
	add		hl,de
	ld		a,(AlphaByte)
	cp		0
	jr		z,NoAdd
	push	hl
	ld		h,a
	ld		l,47
	call	MUL_HL
	pop		de
	add		hl,de
NoAdd:
	ld		a,(hl)
	cp		0
	jr		z,RunGetLoop
	ld		hl,(TextPtr)
	ld		de,TextBuffer+8
	sbc 	hl,de
	jp 		nc,RunGetLoop
	ld		hl,(TextPtr)
	ld		(hl),a
	inc		hl
	ld		(TextPtr),hl
	call	PutPrompt
	jr		RunGetLoop

BackUp:
	ld		hl,(TextPtr)
	ld		de,TextBuffer
	sbc		hl,de
	jp		z,RunGetLoop
	ld		hl,(TextPtr)
	dec		hl
	ld		(TextPtr),hl
	ld		(hl),0
	call	ClearDialogArea
	call	DrawDialogBox
	ld		hl,$191E
	ld		(_penCol),hl
	ld		hl,EnterName
	call	_vputs
	call	PutPrompt
	jp		RunGetLoop

ToggleAlpha:
	ld		a,(AlphaByte)
	cp		2
	call	z,ToggleIt
	inc		a
	ld		(AlphaByte),a
	call	FixPrompt
	call	PutPrompt
	jp		RunGetLoop
ToggleIt:
	ld		a,-1
	ret

PutPrompt:
	ld		hl,$0305
	ld		(_curRow),hl
	ld		hl,PromptBuffer
	call	_puts
	ld		hl,CursorBuffer
	call	_puts
	ret

FixPrompt:
	ld		a,(AlphaByte)
	cp		0
	jr		nz,NotReg
	ld		hl,$DF
	jr		SavePrompt
NotReg:
	cp		1
	jr		nz,NotRegAlpha
	ld		hl,$E1
	jr		SavePrompt
NotRegAlpha:
	ld		hl,$E2
SavePrompt:
	ld		(CursorBuffer),hl
	ret

StringDone:
	ld		de,TextBuffer
	ld		hl,(TextPtr)
	sbc		hl,de
	ld		(_OP1+1),hl
	ld		hl,TextBuffer
	ld		de,_OP1+2
	ld		bc,8
	ldir
	ld		a,1	
	ret

NoSaveName:
	ld		a,0
	ret

TextPtr:
	.dw	TextBuffer

CursorBuffer:
	.db $E1,0			;put the cursor type here

PromptBuffer:
	.db "Name:"			;Put the prompt here

TextBuffer:
	.db 0,0,0,0,0,0,0,0,0

AlphaByte:
	.db 1

JumpTables:
	.db 0,0,0,0,0,0,0
	.db 0,'3','6','9',0,0,0,0
	.db 0,'2','5','8',0,0,0,0
	.db '0','1','4','7',0,0,0,0,0,0
	.db 0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0

	.db 'X','T','O','J','E',0,0
	.db ' ','W','S','N','I','D',0,0
	.db 'Z','V','R','M','H','C',0,0
	.db 'Y','U','Q','L','G','B',0,0,0,0
	.db 'P','K','F','A',0
	.db 0,0,0,0,0,0,0,0,0

	.db 'x','t','o','j','e',0,0
	.db ' ','w','s','n','i','d',0,0
	.db 'z','v','r','m','h','c',0,0
	.db 'y','u','q','l','g','b',0,0,0,0
	.db 'p','k','f','a',0
	.db 0,0,0,0,0,0,0,0,0


;#################
;# Explorer Code #
;#################

ExplorerScreenSetup:
	call	GrayOff
	call	DrawFullScreen
	call	ExplorerDrawMiddle
	ld		b,16
	ld		hl,$FEE0
	call	DrawHLine
	ld		de,$012D
	ld		hl,ExplorerStr
	call	ExplorerDispIt
	
	ld		de,$0901
	ld		hl,Folder1
	call	ExplorerDispIt

	ld		de,$0F01
	ld		hl,Folder2
	call	ExplorerDispIt

	ld		de,$1501
	ld		hl,Folder3
	call	ExplorerDispIt

	ld		de,$1B01
	ld		hl,Folder4
	call	ExplorerDispIt

	ld		de,$2101
	ld		hl,Folder5
	call	ExplorerDispIt

	ld		de,$2701
	ld		hl,Recycle
	call	ExplorerDispIt
	call	ExplorerInvertSelector

ExplorerGetLoop1:
	call	_getcode
	cp		K_UP
	jp		z,ExplorerMoveUp
	cp		K_DOWN
	jp		z,ExplorerMoveDown
	cp		K_SECOND
	jp		z,ExplorerInitVarStuff
	cp		K_RIGHT
	jp		z,ExplorerInitVarStuff
	cp		K_EXIT
	jp		z,Program_Start
	cp		K_PLUS
	call	z,ContrastUp
	cp		K_MINUS
	call	z,ContrastDn
	jr		ExplorerGetLoop1

ExplorerMoveUp:
	ld      a,(Posl)
	push	af
	call    ExplorerInvertSelector
	pop		af
	cp      1
	call	z,ExplorerHopBarDown
	dec     a
	ld		(Posl),a
	call    ExplorerInvertSelector
	ld		a,(Posl)
	call	ExplorerClearProgPlace
	jp		ExplorerGetLoop1

ExplorerHopBarDown:
	ld		a,7
	ret

ExplorerMoveDown:
	ld      a,(Posl)
	push	af
	call    ExplorerInvertSelector
	pop		af
	cp		6
	call	z,ExplorerHopBarUp
	inc		a
	ld		(Posl),a
	call    ExplorerInvertSelector
	call	ExplorerClearProgPlace
	jp		ExplorerGetLoop1

ExplorerHopBarUp:
	ld		a,0
	ret

;##############################
;# Variable Selector Routines #
;##############################

ExplorerInitVarStuff:
	ld		a,(Posl)
	dec		a
	ld		(CurFolder),a
	ld		a,1
	ld		(CurVar),a
	call	ExplorerFindVars
	ld		a,(TotalVars)
	cp		0
	jp		z,ExplorerDispNoProgs
	ld		a,1
	ld		(CurVar),a
	call	ExplorerDispProgs
	ld		a,1

	ld		(Posr),a

	ld		(CurVar),a
	call	ExplorerUpdateCurProg
	call	Move12b
	set		3,(iy+5)
	call	ExplorerDisplayHandler
	call	ExplorerGet_Size
	res		3,(iy+5)

ExplorerGetLoop2:
	call	_getcode
	cp		K_UP
	jp		z,ExplorerProgUp
	cp		K_DOWN
	jp		z,ExplorerProgDown
	cp		K_SECOND
	jp		z,ExplorerExecProg
	cp		K_DEL
	jp		z,ExplorerMove2Recycle
	cp		K_XVAR
	jp		z,ExplorerMoveProg
	cp		K_PLUS
	call	z,ContrastUp
	cp		K_MINUS
	call	z,ContrastDn
	cp		K_LEFT
	jp		z,ExplorerProgLeft
	cp		K_RIGHT
	jp		z,ExplorerProgRight
	cp		K_EXIT
	jp		z,ExplorerBack2Folders
	jr		ExplorerGetLoop2

ExplorerProgLeft:
	ld      a,(Posr)

	sub		7
	jp		c,ExplorerGetLoop2
	call	ExplorerDisplayHandler

	ld		a,(Posr)
	sub		6
	ld		(Posr),a
	ld		a,(CurVar)
	sub		6
	ld		(CurVar),a
	call	ExplorerUpdateCurProg
	call	Move12b
	jp		ExplorerDisplayProg

ExplorerProgRight:
	ld      a,(Posr)

	sub		7
	jp		nc,ExplorerGetLoop2
	ld		a,(CurVar)
	add		a,6
	ld		b,a
	ld		a,(TotalVars)
	sub		b
	jp		c,ExplorerGetLoop2
	call	ExplorerDisplayHandler

	ld		a,(Posr)
	add		a,6
	ld		(Posr),a
	ld		a,(CurVar)
	add		a,6
	ld		(CurVar),a
	call	ExplorerUpdateCurProg
	call	Move12b
	jp		ExplorerDisplayProg

ExplorerProgUp:
	ld		a,(CurVar)
	cp		1
	jp		z,ExplorerGetLoop2
	call	ExplorerDisplayHandler

	ld		a,(CurVar)
	dec		a
	ld		(CurVar),a
	call	ExplorerUpdateCurProg
	call	Move12b
	ld      a,(Posr)

	cp      1

	jr    	nz,ExplorerSkipPageUp
	ld		a,(CurVar)
	sub		11
	ld		(CurVar),a
	call	ExplorerDispProgs
	ld		a,13
ExplorerSkipPageUp:
	dec     a
	ld		(Posr),a

	jp		ExplorerDisplayProg



ExplorerProgDown:
	ld		a,(CurVar)
	ld		hl,TotalVars
	cp		(hl)
	jp		z,ExplorerGetLoop2
	call	ExplorerDisplayHandler
	ld		a,(CurVar)
	inc		a
	ld		(CurVar),a
	call	ExplorerUpdateCurProg
	call	Move12b	

	ld		a,(Posr)
	cp		12
	jr		nz,ExplorerSkipPageDown
	ld		a,(CurVar)
	push	af
	call	ExplorerDispProgs
	pop		af
	ld		(CurVar),a
	call	ExplorerUpdateCurProg
	call	Move12b
	ld		a,0
ExplorerSkipPageDown:
	inc		a
	ld		(Posr),a
ExplorerDisplayProg:
	set		3,(iy+5)
	call	ExplorerDisplayHandler

	res		1,(iy+5)
	call	ExplorerGet_Size
	jp		ExplorerGetLoop2


ExplorerBack2Folders:
	call	ExplorerClearProgPlace
	ld		hl,$3925
	ld		(_penCol),hl
	ld		b,35
ExplorerClearSize:
	ld		a,' '
	call	_vputmap
	djnz	ExplorerClearSize
	ld		hl,$2F01
	ld		(_penCol),hl
	ld		b,29

ExplorerClearType:
	ld		a,' '
	call	_vputmap
	djnz	ExplorerClearType
	call	ExplorerClearDescriptPlace
	jp		ExplorerGetLoop1

ExplorerDispNoProgs:
	ld		hl,$1B33
	ld		(_penCol),hl
	ld		hl,NoProgs_Str
	call	_vputs
	jp		ExplorerGetLoop1
	
ExplorerExecProg:
	call	_push_op1
	call	SaveVars
	call	_pop_op1
	rst 	10h

	call	ExecProgram
	call	DrawDesktop
	call	GetFreeMem
	jp		ExplorerScreenSetup


ExplorerMoveProg:
	ld		a,1
	ld		(PointerPos),a
	call	ExplorerPlaceArrow

ExplorerGetLoop3:
	call	_getcode
	cp		K_UP
	jr		z,ExplorerMovePointerUp
	cp		K_DOWN
	jr		z,ExplorerMovePointerDn
	cp		K_SECOND
	jp		z,ExplorerMove2Folder
	cp		K_EXIT
	jr		nz,ExplorerGetLoop3
	ld		a,(PointerPos)
	call	ExplorerEraseArrow
	jp		ExplorerGetLoop2

ExplorerMovePointerUp:
	call	ExplorerEraseArrow
	ld		a,(PointerPos)
	cp		1
	call	z,ExplorerHopPointerDown
	dec		a
	ld		(PointerPos),a
	call	ExplorerPlaceArrow
	jr		ExplorerGetLoop3

ExplorerHopPointerDown:
	ld		a,7
	ret

ExplorerMovePointerDn:
	call	ExplorerEraseArrow
	ld		a,(PointerPos)
	cp		6
	call	z,ExplorerHopPointerUp
	inc		a
	ld		(PointerPos),a
	call	ExplorerPlaceArrow
	jr		ExplorerGetLoop3

ExplorerHopPointerUp:
	ld		a,0
	ret

ExplorerEraseArrow:
	call	ExplorerGetPointerOffset
	ld		hl,Spaces_Str
	call	_vputs
	ret

ExplorerPlaceArrow:
	call	ExplorerGetPointerOffset
	ld		a,$CF
	call	_vputmap
	ret

ExplorerGetPointerOffset:
	ld		a,(PointerPos)
	ld		h,a
	ld		l,6
	call	MUL_HL
	ld		de,3
	add		hl,de
	ld		(_penRow),hl
	ld		a,34
	ld		(_penCol),a
	ret

ExplorerMove2Recycle:
	ld		a,(CurFolder)
	cp		5
	jp		z,ExplorerDeleteProg
	ld		a,5
	jr		ExplorerMoveIt

ExplorerMove2Folder:
	ld		a,(PointerPos)
	push	af
	call	ExplorerEraseArrow
	pop		af
	dec		a
	
ExplorerMoveIt:
	push	af
	rst		10h
	ld		de,-4
	add		hl,de
	pop		af
	ld		(hl),a
	call	ExplorerClearProgPlace
	call	ExplorerClearDescriptPlace
	jp		ExplorerInitVarStuff
	
ExplorerDeleteProg:
	rst		10h
	call	nc,_delvar
	call	ExplorerClearProgPlace
	call	ExplorerClearDescriptPlace
	call	GetFreeMem
	jp		ExplorerInitVarStuff

ExplorerGet_Size:
	call	_push_op1
	rst		10h
	ld		a,b
	ex		de,hl
	call	_load_ram_ahl	
	in		a,(6)
	out		(5),a
	inc		a
	out		(6),a
	ld		de,-$4000
	add		hl,de
	ld		a,(hl)
	ld		(_OP2+2),a
	inc		hl
	ld		a,(hl)
	ld		(_OP2+1),a
ExplorerTypeFind:
	inc		hl
	push	hl						;first type byte
	ld		a,(hl)
	cp		0
	jr		z,ExplorerChk_Basic

	inc		hl
	ld		a,(hl)

	cp		$27

	jr		z,ExplorerHexProg

	cp		$29

	jr		z,ExplorerProtectedProg

	cp		$28

	jp		z,ExplorerAsmProg

	jr		ExplorerCompiledBasic


ExplorerChk_Basic:
	inc		hl

	ld		a,(hl)
	cp		'A'
	jr		nz,ExplorerUnCompiledBasic
	inc		hl

	ld		a,(hl)
	cp		's'
	jr		nz,ExplorerUnCompiledBasic
	inc		hl

	ld		a,(hl)
	cp		'm'
	jr		nz,ExplorerUnCompiledBasic
	inc		hl

	ld		a,(hl)

	cp		'P'

	jr		nz,ExplorerUnCompiledBasic
ExplorerHexProg:
	pop		hl
	ld		a,'H'

	ld		(_OP2),a
	jp		ExplorerRegularMove


ExplorerUnCompiledBasic:
	ld		a,'B'
	ld		(_OP2),a
	pop		hl
	inc		hl
	ld		a,(hl)
	cp		$3a
	jr		nz,ExplorerRegularMove+1
	inc		hl
	ld		a,(hl)
	cp		$22
	jr		nz,ExplorerRegularMove+1
	inc		hl
	ld		de,_OP2+3
ExplorerCopyBasicDesc:
	ld		a,(hl)
	cp		$22
	jr		z,ExplorerPutEndingZero
	ld		(de),a
	inc		hl
	inc		de
	jr		ExplorerCopyBasicDesc
ExplorerPutEndingZero:
	xor		a
	ld		(de),a
	jp		ExplorerDisplayInfo

ExplorerCompiledBasic:
	ld		a,'B'
	ld		(_OP2),a
	pop		hl
	ld		a,(hl)
	cp		$6E
	jr		nz,ExplorerRegularMove+1
	inc		hl
	ld		a,(hl)
	cp		$2D
	jr		nz,ExplorerRegularMove+1
	inc		hl
	ld		de,_OP2+3
ExplorerCopyBasicDesc2:
	ld		a,(hl)
	cp		0
	jr		z,ExplorerPutEndingZero
	ld		(de),a
	inc		hl
	inc		de
	jr		ExplorerCopyBasicDesc2

ExplorerProtectedProg:
	ld		a,'P'

	ld		(_OP2),a
ExplorerRegularMove:
	pop		hl
	ld		hl,_OP1+2
	ld		de,_OP2+3
	ld		a,(_OP1+1)
	ld		c,a
	ld		b,0
	ldir
	xor		a
	ld		(de),a
	jp		ExplorerDisplayInfo
	
ExplorerAsmProg:
	ld		a,'A'

	ld		(_OP2),a
	pop		hl
	inc		hl
	inc		hl
	ld		a,(hl)
	cp		0

	jr		nz,ExplorerRegularMove+1

	inc		hl
	ld		a,(hl)
	cp		0
	jr		z,ExplorerRegularMove+1
	dec		hl
	push	hl				;nop is here

	ld		de,6

	add		hl,de

	ld		e,(hl)

	inc		hl

	ld		d,(hl)

	ex		de,hl

	ld		de,$D748

	sbc		hl,de

	pop		de

	add		hl,de

	ld		de,_OP2+3
	ld		bc,27
	ldir

ExplorerDisplayInfo:
	ld		a,$0D
	out		(5),a
	ld		a,$41
	out		(6),a
	res		3,(iy+5)
	ld		de,$3925

	ld		(_penCol),de
	ld		hl,SizeStr
	call	_vputs

	ld		a,(_OP2+2)
	ld		l,a
	ld		a,(_OP2+1)
	ld		h,a
	xor		a

	ld		de,-1

	ld		(_curRow),de

	call	_dispahl

	dec		hl

	call	_vputs
	ld		b,13
ExplorerBustOutSomeSpaces:
	ld		a,' ' 
	call	_vputmap
	djnz	ExplorerBustOutSomeSpaces
	ld		de,$2F05

	ld		(_penCol),de
	ld		hl,TypeStr
	call	_vputs
	ld		a,(_OP2)
	call	_vputmap
	call	ExplorerClearDescriptPlace
	ld		de,$2F23

	ld		(_penCol),de
	ld		hl,_OP2+3
	call	_vputs
	call	_pop_op1
	ret

ExplorerDisplayHandler:
	set		1,(iy+5)
	ld		a,(Posr)

	cp		7
	ld		b,38
	push	bc
	jr		c,FirstCol
SecondCol:
	sub		6
	pop		bc
	ld		b,82
	push	bc
FirstCol:
	ld		h,a

	ld		l,6

	call	MUL_HL

	inc		hl
	inc		hl
	inc		hl
	ld		(_penRow),hl

	pop		bc
	ld		a,b

	ld		(_penCol),a

	ld		hl,Spaces_Str
	call	_vputs
	ld		a,(_OP1+1)
	ld		b,a
	ld		hl,_OP1+2
	call	_vputsn
	ld		hl,Spaces_Str
	call	_vputs
	res		1,(iy+5)
	ret

ExplorerFindVars:
	ld		hl,0
	ld		(TotalVars),hl
	call	$47F3
	ld		hl,AVAT
	ld		(Pointer2AVAT),hl
	ld		hl,$BFFF
ExplorerSearchLoop:
	ld 		de,(VAT_END)
	inc 	de
	or 		a
	sbc 	hl,de
	ret		c
	add 	hl,de
	ld 		a,(hl)
	cp		$12
	jr		nz,ExplorerNotInCurFolder
	ld		de,-4
	add		hl,de
	ld		b,(hl)
	dec		hl
	dec		hl
	ld		c,(hl)
	ld		de,6
	add		hl,de
	ld		a,(CurFolder)
	cp		b
	jr		nz,ExplorerNotInCurFolder
	ld		a,c
	cp		$10
	jr		z,ExplorerNotInCurFolder
	cp		'#'
	jr		z,ExplorerNotInCurFolder
	cp		'!'
	jr		z,ExplorerNotInCurFolder
	cp		'z'
	jr		nz,ExplorerProgFound
	ld		de,-7
	add		hl,de
	ld		a,(hl)
	dec		hl
	ld		b,(hl)		
	ld		de,8
	add		hl,de
	cp		'a'
	jr		nz,ExplorerProgFound
	ld		a,b
	cp		'p'
	jr		nz,ExplorerProgFound

ExplorerNotInCurFolder:
 	dec 	hl
	dec 	hl
	dec 	hl
	dec 	hl
	dec 	hl
 	ld 		b,(hl)
 	inc 	b
ExplorerSkipName:
	dec 	hl
	djnz 	ExplorerSkipName
	jr 		ExplorerSearchLoop

ExplorerProgFound:
	dec 	hl				
	dec 	hl
	dec 	hl
	dec 	hl
	dec 	hl
	ld 		b,(hl)
	ld 		ix,(Pointer2AVAT)
	ld 		a,$12
	ld 		(ix),a
	inc		ix
	ld		a,b
	ld		(ix),a
	inc		ix
ExplorerSaveName:
	dec 	hl
	ld 		a,(hl)
	ld 		(ix),a
	inc 	ix
	djnz 	ExplorerSaveName
	ld 		(ix),$0
	dec 	hl
	ld 		(Pointer2VAT),hl
	ld		hl,(Pointer2AVAT)
	ld		de,12
	add		hl,de
	ld		(Pointer2AVAT),hl
	ld		a,(TotalVars)
	inc		a
	ld		(TotalVars),a
	ld		hl,(Pointer2VAT)
	jp		ExplorerSearchLoop

ExplorerDispProgs:
	call	ExplorerClearProgPlace	
	ld		a,1
	ld		(Posr),a
	call	ExplorerUpdateCurProg
ExplorerTheMoveLoop:
	call	Move12b
	call	ExplorerDisplayHandler
	ld		a,(Posr)
	inc		a
	ld		(Posr),a
	cp		13
	ret		z
	ld		a,(CurVar)
	ld		hl,TotalVars
	cp		(hl)
	ret		z
	inc		a
	ld		(CurVar),a
	call	ExplorerUpdateCurProg
	jr		ExplorerTheMoveLoop	

ExplorerUpdateCurProg:
	ld		a,(CurVar)
	ld		h,a
	ld		l,12
	call	MUL_HL
	ld		de,AVAT-12
	add		hl,de
	ret

ExplorerClearProgPlace:
	ld		hl,$FC94
	ld		c,37

	ld		b,11

ExplorerClearVars:
	ld		a,0
	ld		(hl),a

	inc		hl

	djnz 	ExplorerClearVars

	ld		de,5

	add		hl,de

	dec		c

	ld		a,c

	or		a

	ld		b,11
	jr		nz,ExplorerClearVars

ExplorerDrawMiddle:
	ld		b,45

	ld		hl,$FC94

	ld		c,%10000000

	ld		de,16

	call	DrawVLine
	ret

ExplorerClearDescriptPlace:
	ld		hl,$FEF5
	ld		c,6

	ld		b,10

ExplorerClearDescript:
	ld		a,0
	ld		(hl),a

	inc		hl

	djnz 	ExplorerClearDescript

	ld		de,6

	add		hl,de

	dec		c

	ld		a,c

	or		a

	ld		b,10
	jr		nz,ExplorerClearDescript

	ld		hl,$2F23
	ld		(_penCol),hl
	ld		b,7

ExplorerClearDesc:
	ld		a,' '
	call	_vputmap
	djnz	ExplorerClearDesc
	ld		hl,$2F78
	ld		(_penCol),hl
	ld		b,6

ExplorerClearDesc2:
	ld		a,' '
	call	_vputmap
	djnz	ExplorerClearDesc2
	ret

ExplorerDispIt:
	ld		(_penCol),de
	call	_vputs
	ret

ExplorerInvertSelector:
	ld      a,(Posl)
	ld      h,a
	ld      l,$60
	call    MUL_HL
	ld      de,$FC30
	add     hl,de			
	call    ExplorerInvertBar
	call	DrawOverSide
	ret

ExplorerInvertBar:
	ld		c,7

	ld		b,4

ExplorerInverter:
	ld		a,(hl)
	cpl
	ld		(hl),a

	inc		hl

	djnz 	ExplorerInverter

	ld		de,12

	add		hl,de

	dec		c

	ld		a,c

	or		a

	ld		b,4
	jr		nz,ExplorerInverter

	ret

DrawOverSide:
	ld		b,45

	ld		hl,$FC80

	ld		c,%10000000

	ld		de,16

	call	DrawVLine
	ret

ExplorerExit:
	call	_clrScrn
	jp		Program_Start


;####################
;# Utility Routines #
;####################

SaveVars:
	ld		hl,zapVAT
	rst		20h
	rst		10h
	ret		c
	ld		a,b
	ex		de,hl
	call	_load_ram_ahl
	in		a,(5)
	push	af
	in		a,(6)
	out		(5),a	
	inc		a
	out		(6),a
	ld		de,$4000
	sbc		hl,de
	ld		de,Pos-$D748+4
	add		hl,de
	ld		bc,59
	ex		de,hl
	ld		hl,Pos
	ldir
	pop		af
	out		(5),a
	ret

InvertSelector:
	ld      a,(Pos)
	ld      h,a
	ld      l,$60
	call    MUL_HL
	ld      de,$FD21
	add     hl,de			
	call    InvertBar
	ret

InvertBar:
	ld		c,7

	ld		b,5

Inverter:
	ld		a,(hl)
	cpl
	ld		(hl),a

	inc		hl

	djnz 	Inverter

	ld		de,11

	add		hl,de

	dec		c

	ld		a,c

	or		a

	ld		b,5
	jr		nz,Inverter

	ret

ClearStartMenu:
	ld		hl,$FD60
	ld		c,34

	ld		b,6

ClearStartLoop:
	xor		a
	ld		(hl),a

	inc		hl

	djnz 	ClearStartLoop

	ld		de,10

	add		hl,de

	dec		c

	ld		a,c

	or		a

	ld		b,6
	jr		nz,ClearStartLoop

	ret

ShutCalcOff:
	res		3,(iy+8)

	set		4,(iy+8)

	call 	_off

	ld		a,$FF
	ret

GetFreeMem:
	ld		hl,$3955
	ld		(_penCol),hl
	ld		hl,FreeStr
	call	_vputs
	call	_MEMCHK

	call	DispHL
	ret

InvertFullBar:
	ld      b,$70

InvertFullBarLoop:
	ld      a,(hl)

	cpl
	ld      (hl),a

	inc     hl

	djnz	InvertFullBarLoop

	ret

ContrastDn:
	ld		b,-1

	jr		ContrastMain

ContrastUp:
	ld		b,1

ContrastMain:
	ld		a,(CONTRAST)

	add		a,b

	and		$1F

	ld		(CONTRAST),a

	out		(2),a

	halt
	halt
	halt
	halt
	halt
	halt
	halt
	ld		a,$FF
	ret

DrawIcon:
	ld		b,8
PutLine:
	push	bc
	ld		a,(de)
	ld		(hl),a
	inc		de
	push	bc
	ld		bc,16
	add		hl,bc
	pop		bc
	djnz	PutLine
	ret

ErrorNoProg:
	call	DrawDialogBox
	ld		hl,$1731
	ld		(_penCol),hl
	ld		hl,Error
	call	_vputs
	ld		hl,$2718
	ld		(_penCol),hl
	ld		hl,ErrorNoProgStr
	call	_vputs
	call	$4d43
	call	ClearDialogArea
	ret

ClearDialogArea:
	ld		hl,$FD60
	ld		c,34

	ld		b,14

ClearDialogLoop:
	xor		a
	ld		(hl),a

	inc		hl

	djnz 	ClearDialogLoop

	ld		de,2

	add		hl,de

	dec		c

	ld		a,c

	or		a

	ld		b,14
	jr		nz,ClearDialogLoop

	ret

DrawDialogBox:
	call	ClearDialogArea
	ld		b,34

	ld		hl,$FD60

	ld		c,%10000000

	ld		de,16

	call	DrawVLine
	ld		b,31

	ld		hl,$FD60

	ld		c,%00000001

	ld		de,16

	call	DrawVLine
	ld		b,32

	ld		hl,$FD6F

	ld		c,%10000000

	ld		de,16

	call	DrawVLine
	ld		b,31

	ld		hl,$FD7F

	ld		c,%01000000

	ld		de,16

	call	DrawVLine
	ld		b,14
	ld		hl,$FD61
	call	DrawHLine
	ld		b,14
	ld		hl,$FDE1
	call	DrawHLine
	ld		b,14
	ld		hl,$FF41
	call	DrawHLine
	ld		hl,$FF51
	ld		a,%01111111
	ld		(hl),a
	ld		b,13
	ld		hl,$FF52
	call	DrawHLine
	ret

DrawFullScreen:
	xor		a
	ld		hl,$FC00
	ld		(hl),a
	ld		de,$FC01
	ld		bc,1023 - (8*16)	
	ldir
	ld		b,54

	ld		hl,$FC00

	ld		c,%10000000

	ld		de,16

	call	DrawVLine
	ld		b,53

	ld		hl,$FC1F

	ld		c,%00000001

	ld		de,16

	call	DrawVLine
	ld		b,54

	ld		hl,$FC0F

	ld		c,%00000010

	ld		de,16

	call	DrawVLine
	ld		b,15
	ld		hl,$FC00
	call	DrawHLine
	ld		hl,$FC0F
	ld		a,%11111110
	ld		(hl),a
	ld		b,16
	ld		hl,$FC80
	call	DrawHLine
	ld		b,16
	ld		hl,$FF50
	call	DrawHLine
	ld		hl,$FF60
	ld		a,%01111111
	ld		(hl),a
	ld		b,15
	ld		hl,$FF61
	call	DrawHLine
	ret

Move12b:
	ld		bc,12
	ld		de,_OP1
	ldir
	ret

DrawVLine:
	ld		a,(hl)
	or		c
	ld		(hl),a
	add		hl,de

	djnz	DrawVLine

	ret

DrawHLine:
	ld		a,$FF
	ld		(hl),a

	inc		hl

	djnz	DrawHLine

	ret

DrawTallSprite:
	push	bc
	ld		a,(de)
	ld		(hl),a
	inc		de
	ld		bc,16
	add		hl,bc

	pop		bc
	djnz	DrawTallSprite

	ret

DispHL:
	ld		de,-1

	ld		(_curRow),de

	call	_dispahl

	dec		hl

	call	_vputs

	ret

FindSpriteCoords:
	ld		a,(SpritePos)
	add		a,a
	dec		a
	dec		a
	ld		e,a
	ld		d,0
	ld		hl,SpriteTable
	add		hl,de
	ld		a,(hl)
	ld		(SpriteX),a
	inc		hl
	ld		a,(hl)
	ld		(SpriteY),a
	ret

DrawDesktop:
	ld		b,16
	ld		hl,$FF80
	call	DrawHLine
	ld		b,64

	ld		hl,$FC00

	ld		c,%10000000

	ld		de,16

	call	DrawVLine
	ld		b,64

	ld		hl,$FC0F

	ld		c,%00000001

	ld		de,16

	call	DrawVLine
	ld		b,16
	ld		hl,$FC00
	call	DrawHLine
	ld		hl,$3902
	ld		(_penCol),hl
	ld		hl,StartStr
	call	_vputs
	ld		b,16
	ld		hl,$FFF0
	call	DrawHLine
	ret

GrayOn:
	ld		hl,GrayPic
	rst		20h
	rst		10h
	ret		c
	ld		a,b
	ex		de,hl
	call	_load_ram_ahl
	in		a,(5)
	push	af
	in		a,(6)
	out		(5),a
	inc		a
	out		(6),a
	ld		de,$4000
	sbc		hl,de
	inc		hl
	inc		hl
	ld		de,$CA00
	ld		bc,1008
	ldir
	pop		af
	out		(5),a
	call	OpenGray
	ret

GrayOff:
	push	bc
	push	de
	bit		2,(iy+$23)
	call	nz,CloseGray
	pop		de
	pop		bc
	ret

UseStandardSprite:
	ld		hl,StandardSprite
	ret

FastSprite:
	push af
	push bc
	push de
	push ix
	push hl
	push hl                 ;\
	pop ix                  ; > hl -> ix
	ld hl, FSByte           ;> point to Tempbyte
	ld (hl), c              ;> put c into Byte for later use
	ld a, b
	rrca                    ;\
	rrca                    ; > divide x by 8 in accumulator
	rrca                    ;/                      
	rld                     ;> Rotate left 4 bytes  
	or $FC                  ;> add a and $FC
	ld l, (hl)              ;\
	ld h, a                 ; > buncha loading going on
	ld a, b                 ;/
	and 7                   ;> mask out the shift number
	ld d, a                 ;> save the shift number
	ld e, 8
FSLoop:                         
	ld a, (ix)              ;> get sprite data
	ld b, a
	inc ix                  ;> point to new sprite data byte
	ld c, 0                 ;> clear c for shift use
	ld a, d                 ;> restore shift # for use
	cp 0
	jp z, NoShift
	ld a, b
	ld b, d
FSShift:
	srl a                   ;\
	rr c                    ; \
	dec b                   ;  > shift until b < 0
	jp z, Shiftend          ; /
	jp FSShift              ;/
NoShift:
	ld a, b
Shiftend:
	or (hl)                 ;> mix the shifted sprite w/screen
	ld (hl), a              ;> and draw it to the screen
	inc hl                  ;> hl points to next screen byte
	ld a, c                 ;> accumulate the remaining shifted data
	or (hl)                 ;> mix 'em
	ld (hl), a              ;> draw it
	ld a, 15                ;\
	add a, l                ; \
	ld l, a                 ;  > Inc the <HL> 1 y value.
	jp nc, FSNoinc          ; /
	inc h                   ;/
FSNoinc:
	dec e                   ; >check if loop is finished
	jp nz, FSLoop           ;/
	pop hl                  ;\
	pop ix                  ; \
	pop de                  ;  > mmmpop boop be doop mmmpop
	pop bc                  ; /  
	pop af                  ;/
	ret
FSByte: .db $00

BackUpScreen:
	push	hl
	push	de
	push	bc
	ld		hl,$FC00
	ld		de,$EC00
	ld		bc,56*16
	ldir
	pop		bc
	pop		de
	pop		hl
	ret

RestoreScreen:
	push	hl
	push	de
	push	bc
	ld		hl,$EC00
	ld		de,$FC00
	ld		bc,56*16
	ldir
	pop		bc
	pop		de
	pop		hl
	ret

;Input
;hl=x1,y1
;de=x2,y2
;bc=where the cursor is
;Output
;z flag set if bc is in the region bounded by x1,y1-x2,y2
;There is one hitch; It only detects correctly if the mouse is one
;pixel inside of the given dimensions, so increase/decrease the inputs
;by one pixel to make it work correctly.

InArea:
	ld		a,b
	sub		d
	jr		nc,NotInArea
	ld		a,h
	sub		b
	jr		nc,NotInArea
	ld		a,c
	sub		e
	jr		nc,NotInArea
	ld		a,l
	sub		c
	jr		nc,NotInArea
	cp		a
	ret

NotInArea:
	ld		a,1
	cp		0
	ret


;#######################################
;# Execute Program                     #
;# with name in op1 and address in bde #
;#######################################

ExecProgram:
	call	GrayOff
	ld		a,b

	ex		de,hl

	call	_load_ram_ahl

	inc		hl

	inc		hl

	xor		a

	cp		(hl)

	jr		z,CheckHex

	inc		hl

	ld		a,(hl)

	cp		$27					;tokenized hex

	jr		z,ExecAsm

	cp		$29					;protected basic

	jr		z,ExecBasic

	cp		$28					;assembly

	jr		z,ExecAsm


CheckHex:
	inc		hl

	ld		a,(hl)
	cp		'A'
	jr		nz,ExecBasic
	inc		hl

	ld		a,(hl)
	cp		's'
	jr		nz,ExecBasic
	inc		hl

	ld		a,(hl)
	cp		'm'
	jr		nz,ExecBasic
	inc		hl

	ld		a,(hl)

	cp		'P'

	jr		z,ExecAsm



ExecBasic:
	call	_runon

	call	_exec_basic

	ei
	ret


ExecAsm:
	call	_exec_asm

	ei
	ret

#include "mygsl.asm"

;################################
;# Strings used in main program #
;################################

EnterName:
	.db "Enter Program Name:",0

Error:
	.db "Error!",0

ErrorNoProgStr:
	.db "Program Does Not Exist",0

StartStr:
	.db "Start",0

FreeStr:
	.db "Free:",0

ProgsStr:
	.db "Programs",0

DocsStr:
	.db "Docs",0

CtrlStr:
	.db "Control",0

RunStr:
	.db "Run",0

OffStr:
	.db "Shut Down",0

ControlPanelStr:
	.db "Control Panel",0

BackPicStr:
	.db "BackPic:",0

ScreenOffset:
	.dw 0000

EditorVAT:
	.db $00,$03,"TiL"

zapVAT:
	.db $00,$07,"zap2000"

NonePic:
	.db $11,$05,"~none"

NoneProg:
	.db $12,$05,"~none"

;##########################
;# Data/Text for Explorer #
;##########################

ExplorerStr:
	.db "Explorer",0
Folder1:
	.db "/root",0
Folder2:
	.db "/games",0
Folder3:
	.db "/math",0
Folder4:
	.db "/science",0
Folder5:
	.db "/misc",0
Recycle:
	.db "/recycle",0

SizeStr:
	.db "Size:",0

TypeStr:
	.db "Type:",0

Spaces_Str:
	.db "   ",0

NoProgs_Str:
	.db "No Programs",0

;#############################
;# Sprites used in Program   #
;#############################

MouseSprite:
	.db %11111110
	.db %11111100
	.db %11111000
	.db %11111100
	.db %11111110
	.db %11011111
	.db %10001111
	.db %00000110

MyCalcSprite:
	.db %11111111
	.db %10000001
	.db %10000001
	.db %11111111
	.db %10101001
	.db %10010101
	.db %10101001
	.db %11111111

StandardSprite:
	.db 8,1
	.db %11111111
	.db %10011001
	.db %10100101
	.db %10100101
	.db %10111101
	.db %10100101
	.db %10100101
	.db %11111111

MenuSprite:
	.db %11111111
	.db %11111110
	.db %11000110
	.db %10111010
	.db %11000110
	.db %11111110
	.db %11000110
	.db %10111010
	.db %11000110
	.db %11111110
	.db %11000110
	.db %10111010
	.db %11000110
	.db %11111110
	.db %11011010
	.db %10101010
	.db %10110010
	.db %11111110
	.db %11101110
	.db %11101110
	.db %11111110
	.db %11011110
	.db %10101110
	.db %10000010
	.db %11111110
	.db %11000010
	.db %10110110
	.db %11000010
	.db %11111110
	.db %10011010
	.db %10101010
	.db %10110010
	.db %11111110
	.db %00000010

MyCalcStr:
	.db "My Calc",0

Shortcut1Str:
	.db "Shortcut #1:",0
Shortcut2Str:
	.db "Shortcut #2:",0
Shortcut3Str:
	.db "Shortcut #3:",0
Shortcut4Str:
	.db "Shortcut #4:",0

FirstPossibleProgram:
	.db $12,$01,$01

;Save From Here
Pos:
	.db 4
Posl:
	.db	1
MouseX:
	.db 1
MouseY:
	.db 1
GrayPic:
	.db $11,$05,"~none   ",0

Shortcut1:
	.db $12,$05,"~none   ",0

Shortcut2:
	.db $12,$05,"~none   ",0

Shortcut3:
	.db $12,$05,"~none   ",0

Shortcut4:
	.db $12,$05,"~none   ",0
;To Here

SpriteX:
	.db 0
SpriteY:
	.db 0
SpritePos:
	.db 0
SpriteTable:
	.db 15,2
	.db 15,20
	.db 15,38
	.db 52,2
	.db 52,20
	.db 52,38
	.db 89,2
	.db 89,20
	.db 89,38

Posr:
	.db 0
CurVar:
	.db 0
CurFolder:
	.db 0
ProgEnd:
.end
